'mdObject - by MOD
'20140118

'http://docs.oracle.com/javase/6/docs/api/java/lang/Object.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf


#Ifndef __MDOBJECT_BI__
#Define __MDOBJECT_BI__

Type mdObject Extends Object
	Public:
	Declare Virtual Function equals(ByRef obj As mdObject) As Boolean
	'Declare Virtual Function getClass() As mdClass(?)
	Declare Virtual Function getClass() As String
	Declare Virtual Function hashCode() As Integer
	'Declare Virtual Sub notify()
	'Declare Virtual Sub notifyAll()
	Declare Virtual Function toString() As String 
	'Declare Virtual Sub wait()
	'Declare Virtual Sub wait(timeout As Long)
	'Declare Virtual Sub wait(timeout As Long, nanos As Integer)
	
	Protected:
	Declare Virtual Function clone() As mdObject
	'Declare Virtual Sub finalize()
End Type

Function mdObject.equals(ByRef obj As mdObject) As Boolean
	Return @This = @obj
End Function

'Function mdObject.getClass() As mdClass(?)
'	
'End Function

Function mdObject.getClass() As String
	Return "mdObject"
End Function

Function mdObject.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

'Sub mdObject.notify()
'	
'End Sub
'
'Sub mdObject.notifyAll()
'	
'End Sub

Function mdObject.toString() As String 
	Return ""
End Function

'Sub mdObject.wait()
'	
'End Sub
'
'Sub mdObject.wait(timeout As Long)
'	
'End Sub
'
'Sub mdObject.wait(timeout As Long, nanos As Integer)
'	
'End Sub

Function mdObject.clone() As mdObject
	Return This
End Function

'Sub mdObject.finalize()
'	
'End Sub

#EndIf '__MDOBJECT_BI__
